package samples.circle 
{
	import biga.CrossHair;
	import biga.shapes2d.Circle;
	import biga.utils.ApolloniusCircles;
	import com.bit101.components.CheckBox;
	import com.bit101.components.HUISlider;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class Apollonius extends Sprite
	{
		
		
		private var crosshairs:Vector.<CrossHair> = new Vector.<CrossHair>();
		private var circles:Vector.<Circle> = new Vector.<Circle>();
		
		private var radius0:HUISlider;
		private var radius1:HUISlider;
		private var radius2:HUISlider;
		
		private var selectAll:CheckBox;
		private var unselectAll:CheckBox;
		private var checkboxes:Vector.<CheckBox> = new Vector.<CheckBox>();
		private var colors:Array;
		
		public function Apollonius() 
		{
			var pts :Vector.<Point> = Vector.<Point>([ new Point( 407, 300 ), new Point(234, 420), new Point(230, 200 ) ] );;
			colors = [ 0xFF0000, 0x00AA00, 0x0000CC, 0xFFCC00 ];
			
			for each( var p:Point in pts )
			{
				
				var circle:Circle = new Circle( p.x, p.y );
				circles.push( circle );
				
				var c:CrossHair = CrossHair( addChild( new CrossHair(0, 6) ) );
				c.x = p.x;
				c.y = p.y;
				crosshairs.push( c );
				
			}
			
			var ox:int = 10, oy:int = -10;
			radius0 = new HUISlider( this, ox, oy += 20, 'radius 1' );
			radius0.value = 40;
			radius1 = new HUISlider( this, ox, oy += 20, 'radius 2' );
			radius1.value = 20;
			radius2 = new HUISlider( this, ox, oy += 20, 'radius 3' );
			radius2.value = 10;
			
			oy += 20
			var r0:CheckBox, r1:CheckBox; 
			for ( var i:int = 0; i < 4; i++ )
			{
				r0 = new CheckBox( this, ox, oy += 20, 'render ' + ( i * 2 ) );
				r1 = new CheckBox( this, ox + 100, oy, 'render ' + ( ( i * 2 ) + 1 ) );
				r0.selected = r1.selected = true;
				checkboxes.push( r0, r1 );
			}
			
			oy += 20
			selectAll = new CheckBox( this, ox, oy += 20, 'select / unselect all', selectAllHandler );
			selectAll.selected = true;
			
			addEventListener( Event.ENTER_FRAME, update );
			
		}
		
		private function selectAllHandler(e:Event):void 
		{
			
			for each( var cb:CheckBox in checkboxes ) cb.selected = selectAll.selected;
			
		}
		
		private function update(e:Event):void 
		{
			graphics.clear();
			var c:Circle;
			var cr:CrossHair;
			var i:int;
			for ( i = 0; i < circles.length; i++ )
			{
				c = circles[ i ];
				c.x = crosshairs[i].x;
				c.y = crosshairs[i].y;
			}
			
			circles[0].radius = radius0.value < 1 ? 1 : radius0.value;
			circles[1].radius = radius1.value < 1 ? 1 : radius1.value;
			circles[2].radius = radius2.value < 1 ? 1 : radius2.value;
			
			var apCircles:Vector.<Circle> = ApolloniusCircles.apolloniusCircles( circles[0], circles[1], circles[2] );
			if ( apCircles == null ) return;
			
			graphics.lineStyle( 0,0,0 );
			for ( i = 0; i < apCircles.length; i++ )
			{
				if ( checkboxes[ i ].selected )
				{
					c = apCircles[ i ];
					graphics.lineStyle( 2, colors[ int( i / 2 ) ] );
					graphics.drawCircle( c.x, c.y, c.radius );
				}
			}
			
			graphics.lineStyle( 2 );
			for each( c in circles ) c.draw( graphics );
			
		}
	}

}