package samples.circle 
{
	
	import biga.CrossHair;
	import biga.shapes2d.Arc;
	import biga.shapes2d.Circle;
	import biga.utils.ArcUtils;
	import biga.utils.CircleUtils;
	import com.bit101.components.CheckBox;
	import com.bit101.components.HUISlider;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class ArcSample extends Sprite 
	{
		
		private var c0:CrossHair;
		private var circle0:Circle;
		private var arc:Arc;
		
		private var circleRadius:HUISlider;
		private var arcStartAngle:HUISlider;
		private var arcLength:HUISlider;
		private var arcSector:CheckBox;
		private var arcSegment:CheckBox;
		private var closestPoint:CheckBox;
		private var arcInvert:CheckBox;
		
		public function ArcSample() 
		{
			c0 = new CrossHair( 0, 12 );
			c0.x = 250;
			c0.y = 250;
			addChild( c0 );
			
			circle0 = new Circle( c0.x, c0.y, 100 );
			arc = new Arc( circle0.x, circle0.y, circle0.radius );
			
			var ox:int = 10;
			var oy:int = -10;
			
			circleRadius = new HUISlider( this, ox, oy += 20, 'radius' );
			circleRadius.maximum = 200;
			circleRadius.value = circle0.radius;
			
			arcStartAngle = new HUISlider( this, ox, oy += 20, 'arc start angle' );
			arcLength = new HUISlider( this, ox, oy += 20, 'arc length' );
			arcLength.value = 60;
			arcStartAngle.maximum = arcLength.maximum = 360;
			
			arcSector = new CheckBox( this, ox, oy += 20, 'sector' );
			arcSegment = new CheckBox( this, ox + 80, oy, 'segment' );
			arcInvert = new CheckBox( this, ox + 160, oy, 'invert' );
			closestPoint = new CheckBox( this, ox, oy += 20, 'closest point ' );
			closestPoint.selected = true;
			
			addEventListener( Event.ENTER_FRAME, update );
			
		}
		
		private function update( e:Event ) :void
		{
			circle0.x = arc.x = c0.x;
			circle0.y = arc.y = c0.y;
			circle0.radius = arc.radius = circleRadius.value;
			
			var p:Point;
			var mouse:Point = new Point( mouseX, mouseY );
			
			graphics.clear();
			
			//arc
			arc.sector = arcSector.selected;
			arc.segment = arcSegment.selected;
			arc.startAngle = arcStartAngle.value / 180 * Math.PI;
			arc.arcLength = arcLength.value / 180 * Math.PI;
			
			if ( arcInvert.selected ) ArcUtils.invert( arc );
			
			graphics.lineStyle( 5, 0xFF0000 );
			
			if ( arc.sector || arc.segment )	graphics.beginFill( 0xFF0000, .35 );
			
			if ( closestPoint.selected && ArcUtils.isPointOnArc( CircleUtils.closestPointOnCircle( mouse, circle0 ), arc ) )
			{
				graphics.lineStyle( 4, 0x0000FF, 1 );
				if( arc.sector || arc.segment )	graphics.beginFill( 0x0000FF, .5 );
			}
			
			arc.draw( graphics );
			graphics.endFill();
			
			graphics.lineStyle( 0 );
			circle0.draw( graphics );
			
			if ( closestPoint.selected )
			{
				
				graphics.lineStyle( 2, 0xAAAAAA );
				p = CircleUtils.closestPointOnCircle( mouse, circle0 );
				graphics.moveTo( mouse.x, mouse.y );
				graphics.lineTo( p.x, p.y );
				graphics.drawCircle( p.x, p.y, 2 );
				
			}
		}
	}

}