package samples.circle
{
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class CircleDoodle extends Sprite 
	{
		private var id:int = 0;
		private var sw:int = 0;
		private var sh:int = 0;
		public function CircleDoodle() 
		{
			sw = stage.stageWidth;
			sh = stage.stageHeight;
			stage.addEventListener( MouseEvent.MOUSE_DOWN, nextShape );
			nextShape( null );
		}
		
		private function nextShape(e:MouseEvent):void 
		{
			graphics.clear();
			var i:int = 100;
			var s:int = 0;
			switch( id ) 
			{
				case s++:
				graphics.beginFill( 0 );
				while ( i-- ) 
				{
					graphics.drawCircle( sw/2, sh/2, i * 12.5 );
				}
				break;
				
				case s++:
				while ( i-- ) 
				{
					graphics.lineStyle( Math.random() * 12.5, 0 );
					graphics.drawCircle( sw/2, sh/2, i * 12.5 );
				}
				break;
				
				case s++:
				graphics.lineStyle( 4, 0 );
				while ( i-- ) 
				{
					var angle:Number = ( i / 50 ) * Math.PI * 2; 
					graphics.drawCircle( sw/2, sh/2 + Math.cos( angle ) * 100, i * 12.5 );
				}
				break;
				
				case s++:
				while ( i-- ) 
				{
					graphics.beginFill( i % 3? 0: i % 2 ? 0x808080 : 0xFFFFFF );
					graphics.drawCircle( sw * Math.random(), sh * Math.random(), 10 + Math.random() * 100);
				}
				break;
				
				case s++:
				while ( i-- ) 
				{
					graphics.beginFill( i % 3? 0: i % 2 ? 0x808080 : 0xFFFFFF , .5);
					graphics.drawCircle( sw / 10 * .5 + snap( sw * Math.random(), sw/10 ), sh / 10 * .5 +  snap( sh * Math.random(), sh/10 ), 25 + Math.random() * 25 );
				}
				break;
				
				case s++:
				graphics.beginFill( 0 );
				while ( i-- ) 
				{
					graphics.drawCircle( sw * Math.random(), sh * Math.random(), 10 + Math.random() * 100 );
				}
				break;
				
			}
			id = ( id + 1 ) % 6;
			
		}
		
		private function snap( value:Number, step:Number ):Number
		{
			return int( value / step ) * step;
		}
		
	}
	
}