package samples.lines 
{
	import biga.CrossHair;
	import biga.shapes2d.Edge;
	import biga.utils.GeomUtils;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class EdgeSample extends Sprite 
	{
		private var c0:CrossHair;
		private var c1:CrossHair;
		private var c2:CrossHair;
		private var edge:Edge;
		
		public function EdgeSample() 
		{
			
			c0 = new CrossHair( 0x0000FF, 12 );
			addChild( c0 );
			c1 = new CrossHair( 0xFF0000, 12 );
			addChild( c1 );
			
			c0.x = 50;
			c1.x = 450;
			c0.y = c1.y = 250;
			
			c2 = new CrossHair( 0, 12 );
			addChild( c2 );
			c2.x = 250;
			c2.y = 150;
			
			edge = new Edge( c0.point, c1.point );
			
			addEventListener( Event.ENTER_FRAME, update );
			
		}
		
		private function update(e:Event):void 
		{
			
			graphics.clear();
			edge.p0 = c0.point;
			edge.p1 = c1.point;
			
			graphics.lineStyle( 4, 0xFFCC00 );
			edge.draw( graphics );
			
			
			var ip:Point;
			
			graphics.lineStyle( 2, GeomUtils.isLeft( c2.point, edge.p0, edge.p1 ) ? 0x00FF00 : 0xFF0000);
			
			ip = GeomUtils.project( c2.point, edge.p0, edge.p1 );
			graphics.moveTo( ip.x, ip.y );
			graphics.lineTo( c2.x, c2.y );
			graphics.drawCircle( ip.x, ip.y, 5 );
			
			ip = GeomUtils.constrain( c2.point, edge.p0, edge.p1 );
			
			if ( ip != null )
			{
				graphics.lineStyle( 4, GeomUtils.isLeft( c2.point, edge.p0, edge.p1 ) ? 0x00FF00 : 0xFF0000, .1 );
				graphics.moveTo( ip.x, ip.y );
				graphics.lineTo( c2.x, c2.y );
				graphics.drawCircle( ip.x, ip.y, 5 );
			}
			
			// normals
			var ln:Edge = edge.leftNormal;
			graphics.lineStyle( 2, 0x00FF00 );
			ln.draw( graphics );
			
			var rn:Edge = edge.rightNormal;
			graphics.lineStyle( 2, 0xFF0000 );
			rn.draw( graphics );
			
			// center
			graphics.lineStyle( 2, 0x003399 );
			graphics.drawCircle( edge.center.x, edge.center.y, 5 );
		}
		
	}

}